#ifndef __CAUSALITO_H__
#define __CAUSALITO_H__

#define VERSION "0.3.2"
#define True 1 
#define False 0
#define SUCCESS 1
#define FAILURE 0
#define EXIT_SUCCESS 0
#define EXIT_FAILURE 1

#define OUTMSG(args...) \
      fprintf(options->outdesc, ## args)
#define ERRMSG(args...) { \
       fprintf(options->logdesc, "Error: "); \
       fprintf(options->logdesc, ## args); \
     }
#define WARNMSG(args...) { \
       fprintf(options->logdesc, "Warning: "); \
       fprintf(options->logdesc, ## args); \
     }
#define VERBMSG(args...) { \
       if (options->verb) { \
         fprintf(options->logdesc, "Info: "); \
         fprintf(options->logdesc, ## args); \
       } \
     }

#define DEBUG(args...) { \
     if (options->debug) { \
       fprintf(stderr, "DEBUG: <%s,%d> ", __FILE__, __LINE__); \
       fprintf(stderr, ## args); \
     } \
   }

#define DEBUG_ENTER_FUNC DEBUG("Entering function \"%s\"\n", __FUNCTION__)
#define DEBUG_EXIT_FUNC DEBUG("Exiting function \"%s\"\n", __FUNCTION__)

/* #define DEBUG_ENTER_FUNC { */
/*   fprintf(stderr, "DEBUG: <%s,%d> Entering function <%s>\n", \ */
/* 	  __FILE__, __LINE__, __FUNCTION_); */

#define BUG(args...) { \
       fprintf(stderr, "*** BUG *** <%s,%d> ", __FILE__, __LINE__); \
       fprintf(stderr, ## args); \
       fprintf(stderr, "*** BUG *** please follow instructions given in the file \"BUGS\".\n"); \
     }

typedef struct _Options * Options;

struct _Options {
  char * infile, * outfile, * logfile;
  FILE * indesc, * outdesc, * logdesc;
  int verb;
  int force;
  int debug;
} ;

/*
 * functions in causalito.c
 */
int parse_cmd_line(int, char **);
int free_and_end(unsigned short int);
Options alloc_and_init_options(void);
void usage(void);

#endif  /*__CAUSALITO_H__ */ 
